/*
 * Routines from Argonne's PMR 2x865,B142.
 * S. Wendy Cheng (x-3596) 8/24/93
 */

#include <errno.h>
/* #include <sys/errno.h> */


int net_recv(fd, buf, size)
int fd;
char *buf;
int size;
{
	int recvd = 0, n;
	int block_counter = 0;

	while (recvd < size) {
		n = read(fd, buf, size);
		if (n < 0)
			if (errno == EWOULDBLOCK || errno == EAGAIN)
			{
				block_counter++;
				continue;
			}	
			else
				err_dump("net_recv error");
		else if (n == 0)
			return(recvd);
		else
			recvd += n;
		printf("net_recv: read count is %d, block_counter is %d\n",
				n, block_counter);
	}
	return(recvd);
}
int net_send(fd, buf, size)
int fd;
char *buf;
int size;
{
	int n, sent=0;
	int write_counter = 0;
	int block_counter = 0;

	while (sent < size)
	{
		write_counter++;
		/* printf( "About to write...\n" ); */
		n = write(fd, buf+sent, size-sent);
		if (n < 0) {
			if (errno == EWOULDBLOCK || errno == EAGAIN) {
				block_counter ++;
				unexpected_read(fd);
				continue;
			}
			else
				err_dump("net_send error!");
		}
		else
			sent +=n;
		printf("net_send: write_counter is %d, block_counter is %d size %d\n",
			write_counter, block_counter,n);
	}
	return(sent);
}
/*
 * Fatal error. Print the message and terminate the process.
 */

err_dump(str)
char *str;
{
	printf("%s: errno = %d\n", str,errno);
        exit(1);
}
	
static int BytesRead = 0;
static int AmServer = 0;
SetAmServer()
{
AmServer = 1;
}
unexpected_read( fd )
int fd;
{
char *p;
int  m;

if (AmServer) {
printf("Trying unexpected read\n");
    /* Only the low-numbered processor attempts to read */
    p = (char *)malloc( 1000 );
    
    m = net_recv( fd, p, 24 );
    BytesRead += m;
    m = net_recv( fd, p, 800 );
    BytesRead += m;
    free( p );
     printf( "Read unexpected a message of size %d\n", m ); 
    }
}

int UnexpectedBytes()
{
return BytesRead;
}
