/*
 * Client using TCP protocol.
 */

#include	"inet.h"
#define         BUFSIZE 1024*1024

main(argc, argv)
int	argc;
char	*argv[];
{
	int			sockfd, rc, sends,sendsize, i, len;
	struct sockaddr_in	serv_addr;
	struct hostent 		*hp;
        char                    buf[BUFSIZE];
	int                     flags;
	int                     optval = 1;


	if (argc != 4) {
		fprintf(stdout,"Usage: tcp_client port hostname sendsize\n");
		exit(1);
	}

sscanf(argv[3],"%d",&sends);


	/*
	 * Fill in the structure "serv_addr" with the address of the
	 * server that we want to connect with.
	 */

	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family	  = AF_INET;
	serv_addr.sin_port        = atoi(argv[1]);
        if ((hp = gethostbyname(argv[2])) == 0) {
                err_dump("gethostbyname fail");
        }
        bcopy(hp->h_addr, (caddr_t)&serv_addr.sin_addr, hp->h_length);

	/*
	 * Open a TCP socket (an Internet stream socket).
	 */

	if ( (sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
		err_dump("client: can't open stream socket");
	setsockopt(sockfd,IPPROTO_TCP,TCP_NODELAY,
		   (char *) &optval,sizeof(optval));

	/*
	 * Connect to the server.
	 */

	if (connect(sockfd, (struct sockaddr *) &serv_addr, 
				sizeof(serv_addr)) < 0)
		err_dump("client: can't connect to server");

	flags = fcntl(sockfd, F_GETFL, 0);
        rc=fcntl(sockfd, F_SETFL, flags | O_NDELAY  | O_NONBLOCK );
        if (rc <0)
                err_dump("nonbk_server: fcntl error");
                                                /* nonblocking I/O */
	for (i = 0; i < sendsize; i ++) {
		buf[i] = 'a';
		}
    for ( i = 0; i< sends; i++ ) {
	  if ((len=net_send(sockfd, buf, 24)) < 0)
		  err_dump("tcp_client net_send error");
	  if ((len=net_send(sockfd, buf, 800)) < 0)
		  err_dump("tcp_client net_send error");
	}
    len -= UnexpectedBytes();
	/*if ((rc=net_recv(sockfd, buf, 24)) < 0)
		err_dump("tcp_client net_recv error"); */
	printf( "Received %d bytes\n", rc );
	close(sockfd);
	exit(0);
}
