/*
 * Server using TCP protocol:
 *
 * This program is created to test Argonne's PMR (2X865,B142).
 * S. Wendy Cheng (x-3596) 8/24/93
 *
 */

#include	"inet.h"
#define		BUFSIZE	1024*1024

main(argc, argv)
int	argc;
char	*argv[];
{
	int			sockfd, newsockfd, clilen, childpid;
	struct sockaddr_in	cli_addr, serv_addr;
	int			rc, size, len;
	char			buf[BUFSIZE];
	int                     flags;
	int      i,               optval = 1;

	if (argc != 3) {
		fprintf(stdout,"Usage: tcp_server port sendsize\n");
		exit(1);
	}

	pname = argv[0];
	size = atoi(argv[2]);

	SetAmServer();

	/*
	 * Open a TCP socket (an Internet stream socket).
	 */

	if ( (sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
		err_dump("server: can't open stream socket");
	setsockopt(sockfd,IPPROTO_TCP,TCP_NODELAY,
		   (char *) &optval,sizeof(optval));

	/*
	 * Bind our local address so that the client can send to us.
	 */

	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family	  = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port        = atoi(argv[1]);

	if (bind(sockfd, (caddr_t)&serv_addr, sizeof(struct sockaddr_in)) < 0)
		err_dump("server: can't bind local address");

	if (listen(sockfd, BACKLOG) < 0)
		err_dump("server: listen fail");

      /* for ( ; ; ) { */
                /*
                 * Wait for a connection from a client process.
                 */

                clilen = sizeof(cli_addr);
                newsockfd = accept(sockfd, &cli_addr, &clilen);
                if (newsockfd <0)
                        err_dump("tcp_server: fork error");
		setsockopt(newsockfd,IPPROTO_TCP,TCP_NODELAY,
			   (char *) &optval,sizeof(optval));

		flags = fcntl(newsockfd, F_GETFL, 0);
        	rc=fcntl(newsockfd, F_SETFL, flags | O_NDELAY | O_NONBLOCK );
        	if (rc <0) 
			err_dump("nonbk_server: fcntl error");

                if ( (childpid = fork()) < 0)
                        err_dump("tcp_server: fork error");

                else if (childpid == 0) {       /* child process */
                        close(sockfd);          /* close original socket */
#ifdef FOO
			while ((len = net_recv(newsockfd, buf, size)) > 0) {
				if (net_send(newsockfd, buf, len) < 0)
					err_dump("str_echo: send error");
        			printf("*** Sendsize is %d\n", size);
			}
#else
			/* The real test is for two processes to 
			   send at each other; they should BOTH get EWOULDBLOCK
			   forever */
			len = size;
      for ( i=0; i<size; i++ ) {
			if ((len=net_send(newsockfd, buf, 24)) < 0)
			    err_dump("tcp_server net_send error");
			if ((len=net_send(newsockfd, buf, 800)) < 0)
			    err_dump("tcp_server net_send error");
	}
            /* if I haven't yet received this... */
			size -= UnexpectedBytes();
			/*if ((rc=net_recv(newsockfd, buf, size)) < 0)
			    err_dump("tcp_server net_recv error"); */
			printf( "Done\n" ); fflush(stdout);
#endif
			close(newsockfd);	
			exit(0);
		}
		close(newsockfd);		/* parent process */
/*	} */
}

